﻿using CognitiveGeology.Components.CognitiveControls.Graph.Services;
using CognitiveGeology.Components.CognitiveControls.Model;
using NUnit.Framework;

namespace CognitiveGeology.CognitiveControls.Test.Graph.Services
{
    [TestFixture]
    public class PointExtractorTests
    {
        private PointExtractor underTest;
        private DataPointCollection pointData;

        public PointExtractorTests()
        {
            this.underTest = new PointExtractor();
        }

        [TestFixtureSetUp]
        public void TestFixtureSetUp()
        {
            var sourceData = new DataPointCollection();

            sourceData.Add(new DataPoint() {MeasureValue = 1, PropertyValue = 4.34});
            sourceData.Add(new DataPoint() {MeasureValue = 1, PropertyValue = 4.25});
            sourceData.Add(new DataPoint() {MeasureValue = 1, PropertyValue = 3.87});
            sourceData.Add(new DataPoint() {MeasureValue = 1, PropertyValue = 3.67});
            sourceData.Add(new DataPoint() {MeasureValue = 1, PropertyValue = 4.05});
            sourceData.Add(new DataPoint() {MeasureValue = 2, PropertyValue = 8.03});
            sourceData.Add(new DataPoint() {MeasureValue = 2, PropertyValue = 8.02});
            sourceData.Add(new DataPoint() {MeasureValue = 2, PropertyValue = 8.01});
            sourceData.Add(new DataPoint() {MeasureValue = 2, PropertyValue = 8.00});

            pointData = underTest.ExtractPoints(sourceData);
        }

        [Test]
        public void Extracts_Discrete_Measure_Values()
        {
            Assert.AreEqual(2, pointData.Count);
            Assert.AreEqual(1, pointData[0].MeasureValue);
            Assert.AreEqual(2, pointData[1].MeasureValue);
        }

        [Test]
        public void Averages_Property_Values()
        {
            Assert.AreEqual(2, pointData.Count);
            Assert.AreEqual(4.0360000000000005d, pointData[0].PropertyValue);
            Assert.AreEqual(8.0149999999999988d, pointData[1].PropertyValue);
        }
    }
}
