﻿using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace CognitiveControls.TestHarness
{
    internal class DataSource
    {
        private readonly Dictionary<string, string[][]> dataStore;

        public DataSource()
        {
            this.dataStore = new Dictionary<string, string[][]>();
        }

        public void LoadData(string name, string filename)
        {
            var lines = File.ReadAllLines(filename);
            var dataSetName = name;
            AddData(dataSetName, lines);
        }

        private void AddData(string name, string[] lines)
        {
            dataStore.Add(name, lines.Select(line => line.Split(',')).ToArray());
        }

        public Dictionary<string, string[][]> Data
        {
            get { return dataStore; }
        }
    }
}
