﻿using System;
using System.ComponentModel;
using System.Windows.Controls;
using Syncfusion.UI.Xaml.Charts;

namespace CognitiveGeology.Components.CognitiveControls.Map
{
    /// <summary>
    /// Interaction logic for MapDirectionControl.xaml
    /// </summary>
    public partial class MapDirectionControl : UserControl
    {
        private double? primaryAxisMinimum;
        private double? primaryAxisMaximum;
        private string primaryAxisHeader;
        private string secondaryAxisHeader;
        private double? secondaryAxisMinimum;
        private double? secondaryAxisMaximum;

        public event PropertyChangedEventHandler PropertyChanged;

        public MapDirectionControl()
        {
            InitializeComponent();
            
        }

        public void Bind(object data, string xPath, string yPath)
        {
            this.locationsData.ItemsSource = data;
            this.locationsData.XBindingPath = xPath;
            this.locationsData.YBindingPath = yPath;
        }

        public double? PrimaryAxisMinimum
        {
            get { return primaryAxisMinimum; }
            set
            {
                primaryAxisMinimum = value;
                NotifyPropertyChanged("PrimaryAxisMinimum");
            }
        }

        public double? PrimaryAxisMaximum
        {
            get { return primaryAxisMaximum; }
            set
            {
                primaryAxisMaximum = value;
                NotifyPropertyChanged("PrimaryAxisMaximum");
            }
        }
        
        public double? SecondaryAxisMinimum
        {
            get { return secondaryAxisMinimum; }
            set
            {
                secondaryAxisMinimum = value;
                NotifyPropertyChanged("SecondaryAxisMinimum");
            }
        }

        public double? SecondaryAxisMaximum
        {
            get { return secondaryAxisMaximum; }
            set
            {
                secondaryAxisMaximum = value;
                NotifyPropertyChanged("SecondaryAxisMaximum");
            }
        }

        public string PrimaryAxisHeader
        {
            get { return primaryAxisHeader; }
            set
            {
                primaryAxisHeader = value;
                NotifyPropertyChanged("PrimaryAxisHeader");
            }
        }

        public string SecondaryAxisHeader
        {
            get { return secondaryAxisHeader; }
            set
            {
                secondaryAxisHeader = value;
                NotifyPropertyChanged("SecondaryAxisHeader");
            }
        }

        private void NotifyPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
            switch (propertyName)
            {
                case "PrimaryAxisHeader":
                    this.locationChart.PrimaryAxis.Header = this.PrimaryAxisHeader;
                    break;
                case "SecondaryAxisHeader":
                    this.locationChart.SecondaryAxis.Header = this.SecondaryAxisHeader;
                    break;
                case "PrimaryAxisMinimum":
                    ((NumericalAxis)this.locationChart.PrimaryAxis).Minimum = PrimaryAxisMinimum;
                    break;
                case "PrimaryAxisMaximum":
                    ((NumericalAxis)this.locationChart.PrimaryAxis).Maximum = PrimaryAxisMaximum;
                    break;
                case "SecondaryAxisMinimum":
                    ((NumericalAxis)this.locationChart.SecondaryAxis).Minimum = SecondaryAxisMinimum;
                    break;
                case "SecondaryAxisMaximum":
                    ((NumericalAxis)this.locationChart.SecondaryAxis).Maximum = SecondaryAxisMaximum;
                    break;
            }
        }
    }
}
